"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const date_fns_1 = require("date-fns");
const dateUtils_1 = require("../misc/dateUtils");
const getEmptyRoadmap = (lastCalendarWeek, futureWeeks) => {
    // Sort the array by closedAt
    const emptyWeeks = [];
    let cptDays = 0;
    const currentDate = dateUtils_1.formatDate(lastCalendarWeek.weekStart);
    while (cptDays < futureWeeks * 7) {
        const weekEnd = date_fns_1.formatISO(date_fns_1.endOfWeek(currentDate), {
            representation: 'date',
        });
        const weekTxt = date_fns_1.getYear(date_fns_1.endOfWeek(currentDate)) + '.' + date_fns_1.getWeek(currentDate);
        if (emptyWeeks.find((week) => week.weekTxt === weekTxt) === undefined) {
            emptyWeeks.push({
                issues: { count: 0 },
                points: { count: 0 },
                weekStart: date_fns_1.formatISO(date_fns_1.startOfWeek(currentDate), {
                    representation: 'date',
                }),
                weekEnd: weekEnd,
                weekTxt: weekTxt,
            });
        }
        currentDate.setDate(currentDate.getDate() + 1);
        cptDays++;
    }
    return emptyWeeks;
};
exports.default = getEmptyRoadmap;
