"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const date_fns_1 = require("date-fns");
/* eslint max-params: ["error", 6] */
/* eslint-env es6 */
const crunchWeeks = (issuesTree, node, closedIssues, emptyCalendar, userConfig) => {
    return issuesTree.treeToArray(node).reduce((acc, item) => {
        const issueExist = closedIssues.find(i => i.key === item.key);
        if (issueExist !== undefined) {
            const firstDayWeekKey = date_fns_1.formatISO(date_fns_1.startOfWeek(new Date(issueExist.closedAt)), {
                representation: 'date',
            });
            acc[firstDayWeekKey].list.push(issueExist);
            acc[firstDayWeekKey].issues.count = acc[firstDayWeekKey].list.length;
            if (issueExist.fields[userConfig.jira.fields.points] !== undefined &&
                issueExist.fields[userConfig.jira.fields.points] !== null) {
                acc[firstDayWeekKey].points.count = acc[firstDayWeekKey].list
                    .filter((issue) => (issue.fields[userConfig.jira.fields.points] !== undefined &&
                    issue.fields[userConfig.jira.fields.points] !== null) ||
                    (issue.fields[userConfig.jira.fields.originalPoints] !==
                        undefined &&
                        issue.fields[userConfig.jira.fields.originalPoints] !== null))
                    .map((issue) => {
                    if (issue.fields[userConfig.jira.fields.points] !== undefined &&
                        issue.fields[userConfig.jira.fields.points] !== null) {
                        return issue.fields[userConfig.jira.fields.points];
                    }
                    return issue.fields[userConfig.jira.fields.originalPoints];
                })
                    .reduce((acc, points) => acc + points, 0);
            }
        }
        return acc;
    }, JSON.parse(JSON.stringify(emptyCalendar)));
};
exports.default = crunchWeeks;
