"use strict";
/*
    This function creates an empty object containing all of the expected days and weeks between the passed dats with zeroed values
*/
Object.defineProperty(exports, "__esModule", { value: true });
const date_fns_1 = require("date-fns");
const issuesClosedByWeek = (issues, userConfig, emptyCalendar) => {
    const weeks = JSON.parse(JSON.stringify(emptyCalendar));
    for (const issue of issues) {
        const firstDayWeekKey = date_fns_1.formatISO(date_fns_1.startOfWeek(new Date(issue.closedAt)), {
            representation: 'date',
        });
        weeks[firstDayWeekKey].list.push(issue);
        weeks[firstDayWeekKey].issues.count = weeks[firstDayWeekKey].list.length;
        if (issue.fields[userConfig.jira.fields.points] !== undefined &&
            issue.fields[userConfig.jira.fields.points] !== null) {
            weeks[firstDayWeekKey].points.count = weeks[firstDayWeekKey].list
                .filter((issue) => issue.fields[userConfig.jira.fields.points] !== undefined &&
                issue.fields[userConfig.jira.fields.points] !== null)
                .map((issue) => issue.fields[userConfig.jira.fields.points])
                .reduce((acc, points) => acc + points, 0);
        }
    }
    return weeks;
};
exports.default = issuesClosedByWeek;
